static char *typetbl[] = { "9260", "9270", NULL };

struct iotbl {
	int key;
	int value;
};
static struct iotbl Freq[] = {
	{	       (40 * 1000),	TDSIO_SAMPLING_40KHZ	},
	{	      (100 * 1000),	TDSIO_SAMPLING_100KHZ	},
	{	      (200 * 1000),	TDSIO_SAMPLING_200KHZ	},
	{	      (500 * 1000),	TDSIO_SAMPLING_500KHZ	},
	{	 (1 * 1000 * 1000),	TDSIO_SAMPLING_1MHZ	},
	{	 (2 * 1000 * 1000),	TDSIO_SAMPLING_2MHZ	},
	{	 (4 * 1000 * 1000),	TDSIO_SAMPLING_4MHZ	},
	{	 (8 * 1000 * 1000),	TDSIO_SAMPLING_8MHZ	},
	{	(16 * 1000 * 1000),	TDSIO_SAMPLING_16MHZ	},
	{	(32 * 1000 * 1000),	TDSIO_SAMPLING_32MHZ	},
	{	(64 * 1000 * 1000),	TDSIO_SAMPLING_64MHZ	},
	{	0,		-1 			}
};
static struct iotbl Bitw[] = {
	{	1,	TDSIO_SAMPLING_1BIT	},
	{	2,	TDSIO_SAMPLING_2BIT	},
	{	4,	TDSIO_SAMPLING_4BIT	},
	{	8,	TDSIO_SAMPLING_8BIT	},
	{	0,		-1 		}
};
static struct iotbl Chan[] = {
	{	1,	TDSIO_SAMPLING_1CH	},
	{	4,	TDSIO_SAMPLING_4CH	},
	{	0,		-1 		}
};
static struct iotbl Filter[] = {
	{	(16 * 1000 * 1000),	TDSIO_SAMPLING_16M	},
	{	 (8 * 1000 * 1000),	TDSIO_SAMPLING_8M	},
	{	 (4 * 1000 * 1000),	TDSIO_SAMPLING_4M	},
	{	 (2 * 1000 * 1000),	TDSIO_SAMPLING_2M	},
	{	0,			TDSIO_SAMPLING_THRU	}
};


static inline int
get_rate(const char *s) {
	char *p;
	int i, val;

	val = (int)strtol(s, &p, 0);
	switch(*p) {
	case 'M': case 'm': val *= 1000;
	case 'K': case 'k': val *= 1000;
	break;
	}
	for (i = 0; Freq[i].key != 0; i++)
		if (Freq[i].key == val)
			break;
	return (Freq[i].value);
}

static inline int
get_width(const char *s) {
	int i, val;

	val = (int)strtol(s, NULL, 0);
	for (i = 0; Bitw[i].key != 0; i++)
		if (Bitw[i].key == val)
			break;
	return (Bitw[i].value);
}

static inline int
get_channels(const char *s) {
	int i, val;

	val = (int)strtol(s, NULL, 0);
	for (i = 0; Chan[i].key != 0; i++)
		if (Chan[i].key == val)
			break;
	return (Chan[i].value);
}

static inline int
get_filter(const char *s) {
	char *p;
	int i, val;

	val = (int)strtol(s, &p, 0);
	switch(*p) {
	case 'M': case 'm': val *= (1000 * 1000);
	break;
	}
	for (i = 0; Filter[i].key != 0; i++)
		if (Filter[i].key == val)
			break;
	return (Filter[i].value);
}

static inline int
key2value(int key, struct iotbl *tbl)
{
	int i;
	for (i = 0; tbl[i].key != 0 && tbl[i].key != key; i++);
	return (tbl[i].value);
}

static inline int
value2key(int value, struct iotbl *tbl)
{
	int i;
	for (i = 0; tbl[i].key != 0 && tbl[i].value != value; i++);
	return (tbl[i].key);
}
